<?php

namespace App\Services\History\Detector;

use App\Services\History\Converter\ConverterContact;
use App\Services\History\Converter\EmailConverter;
use App\Services\History\Converter\ModelEnumConverter;
use App\Services\History\Converter\WhitelistConverter;

class RequirementDetector extends DetectorAbstract
{
    public static function fields(): array
    {
        return [
            'title',
            'status',
            'asset_id',
            'requirement_group_id',
            'reviewed_by',
            'priority',
            'note',
            'mailto',
            'plan_id',
            'comment',
            'close_reason',
            'description',
            'acceptance',
        ];
    }

    public static function diffFields(): array
    {
        return [
            'description',
            'comment',
            'acceptance',
        ];
    }

    public static function converters():array
    {
        return [
            "whitelist" => new WhitelistConverter(),
            "mailto" => new EmailConverter(),
            "status" => new ModelEnumConverter("requirement.status"),
        ];
    }

    public static function arrayFields(): array
    {
        return [
            'mailto'
        ];
    }
}
